

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>4.11. クエリ拡張 &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <script src="../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../genindex.html" />
    <link rel="search" title="検索" href="../search.html" />
    <link rel="next" title="5. サーバー" href="../server.html" />
    <link rel="prev" title="4.10. マイクロブログ検索システムの作成" href="micro_blog.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../en/html/tutorial/query_expansion.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="../server.html" title="5. サーバー"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="micro_blog.html" title="4.10. マイクロブログ検索システムの作成"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../tutorial.html" accesskey="U"><span class="section-number">4. </span>チュートリアル</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">4.11. </span>クエリ拡張</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="query-expansion">
<h1><span class="section-number">4.11. </span>クエリ拡張<a class="headerlink" href="#query-expansion" title="このヘッドラインへのパーマリンク">¶</a></h1>
<p>Groongaの <a class="reference internal" href="../reference/commands/select.html"><span class="doc">select</span></a> コマンドは <code class="docutils literal notranslate"><span class="pre">query_expander</span></code> 引数を受付ます。これを使うとクエリ文字列を拡張することができます。</p>
<p>例えば、&quot;theater&quot;ではなく&quot;theatre&quot;で検索したとしましょう。クエリ拡張では&quot;theater OR theatre&quot;の結果を返します。このようなやりかたで検索漏れを減らせます。これはユーザーが本当にやりたかったことです。</p>
<div class="section" id="preparation">
<h2><span class="section-number">4.11.1. </span>準備<a class="headerlink" href="#preparation" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>クエリ拡張を使うには、文書を格納するテーブルと検索文字列と置換文字列のペアを格納する置換テーブルを作る必要があります。置換テーブルでは主キーが元の文字列、ShortText型のカラムが置換後の文字列をあらわします。</p>
<p>それでは文書テーブルと置換テーブルを作成しましょう。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Doc TABLE_PAT_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Doc body COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Term TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Term Doc_body COLUMN_INDEX|WITH_POSITION Doc body
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Synonym TABLE_PAT_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Synonym body COLUMN_VECTOR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Doc
[
{&quot;_key&quot;: &quot;001&quot;, &quot;body&quot;: &quot;Play all night in this theater.&quot;},
{&quot;_key&quot;: &quot;002&quot;, &quot;body&quot;: &quot;theatre is British spelling.&quot;},
]
# [[0, 1337566253.89858, 0.000355720520019531], 2]
load --table Synonym
[
{&quot;_key&quot;: &quot;theater&quot;, &quot;body&quot;: [&quot;theater&quot;, &quot;theatre&quot;]},
{&quot;_key&quot;: &quot;theatre&quot;, &quot;body&quot;: [&quot;theater&quot;, &quot;theatre&quot;]},
]
# [[0, 1337566253.89858, 0.000355720520019531], 2]
</pre></div>
</div>
<p>このようにすると、検索漏れは起こりません。これは置換テーブルがクエリ文字列として&quot;theater&quot;も&quot;theatre&quot;のいずれも受け付けるからです。</p>
</div>
<div class="section" id="search">
<h2><span class="section-number">4.11.2. </span>検索<a class="headerlink" href="#search" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>では、準備した置換テーブルを使ってみます。まずは <code class="docutils literal notranslate"><span class="pre">query_expander</span></code> を使わずに <code class="docutils literal notranslate"><span class="pre">select</span></code> コマンドを実行してみましょう。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Doc --match_columns body --query &quot;theater&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;body&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;001&quot;,
#         &quot;Play all night in this theater.&quot;
#       ]
#     ]
#   ]
# ]
select Doc --match_columns body --query &quot;theatre&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;body&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         2,
#         &quot;002&quot;,
#         &quot;theatre is British spelling.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>このクエリではクエリ文字列に完全に一致するレコードを返します。</p>
<p>では、 <code class="docutils literal notranslate"><span class="pre">query_expander</span></code> を <code class="docutils literal notranslate"><span class="pre">Synonym</span></code> テーブルの <code class="docutils literal notranslate"><span class="pre">body</span></code> カラムに対して使ってみましょう。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Doc --match_columns body --query &quot;theater&quot; --query_expander Synonym.body
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;body&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;001&quot;,
#         &quot;Play all night in this theater.&quot;
#       ],
#       [
#         2,
#         &quot;002&quot;,
#         &quot;theatre is British spelling.&quot;
#       ]
#     ]
#   ]
# ]
select Doc --match_columns body --query &quot;theatre&quot; --query_expander Synonym.body
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;body&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;001&quot;,
#         &quot;Play all night in this theater.&quot;
#       ],
#       [
#         2,
#         &quot;002&quot;,
#         &quot;theatre is British spelling.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>この場合、クエリ文字列は &quot;theater OR theatre&quot; へと置き換えられます。つまり、検索時に表記揺れを考慮して検索できます。</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">4.11. クエリ拡張</a><ul>
<li><a class="reference internal" href="#preparation">4.11.1. 準備</a></li>
<li><a class="reference internal" href="#search">4.11.2. 検索</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="micro_blog.html"
                        title="前の章へ"><span class="section-number">4.10. </span>マイクロブログ検索システムの作成</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="../server.html"
                        title="次の章へ"><span class="section-number">5. </span>サーバー</a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="../server.html" title="5. サーバー"
             >次へ</a> |</li>
        <li class="right" >
          <a href="micro_blog.html" title="4.10. マイクロブログ検索システムの作成"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../tutorial.html" ><span class="section-number">4. </span>チュートリアル</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">4.11. </span>クエリ拡張</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>